###############################
# STATISTICAL THINKINK (2020) #
###############################

# Title
print("Insights into Machine Learning via PCA")

# Packages for Scientific Computing and Machine Learning
import matplotlib.pyplot as plt
from mpl_toolkits.mplot3d import Axes3D
from sklearn import datasets
from sklearn.decomposition import PCA

# Import IRIS Dataset
iris = datasets.load_iris()
X = iris.data[:, :4]
Y = iris.target

# 2D-Scatterplot of Sepal Length & With (Training-Pattern)
print("Close Image to continue...")

plt.figure(1, figsize=(8, 6))
x_min, x_max = X[:, 0].min() - .5, X[:, 0].max() + .5
y_min, y_max = X[:, 1].min() - .5, X[:, 1].max() + .5
plt.scatter(X[:, 0], X[:, 1], c=Y, cmap=plt.cm.Paired)
plt.xlabel('Sepal length')
plt.ylabel('Sepal width')

plt.xlim(x_min, x_max)
plt.ylim(y_min, y_max)

plt.show()

# 2D-Scatterplot of Petal Length & With (Training-Pattern)
print("Close Image to continue...")

plt.figure(2, figsize=(8, 6))
x_min, x_max = X[:, 2].min() - .5, X[:, 2].max() + .5
y_min, y_max = X[:, 3].min() - .5, X[:, 3].max() + .5
plt.scatter(X[:, 2], X[:, 3], c=Y, cmap=plt.cm.Paired)
plt.xlabel('Petal length')
plt.ylabel('Petal width')

plt.xlim(x_min, x_max)
plt.ylim(y_min, y_max)

plt.show()

# 3D-Scatterplot via PCA abd Training-Patterns
print("Close Image to continue...")

fig = plt.figure(3, figsize=(8, 6))
ax = Axes3D(fig, elev=-160, azim=30)
X_reduced = PCA(n_components=3).fit_transform(iris.data)
ax.scatter(X_reduced[:, 0], X_reduced[:, 1], X_reduced[:, 2], c=Y, cmap=plt.cm.Paired, s=50)
ax.set_xlabel("1st dimension")
ax.w_xaxis.set_ticklabels([])
ax.set_ylabel("2nd dimension")
ax.w_yaxis.set_ticklabels([])
ax.set_zlabel("3rd dimension")
ax.w_zaxis.set_ticklabels([])

plt.show()

# Machine Learning Model (KNN)
from sklearn.model_selection import train_test_split
from sklearn import neighbors
from sklearn.metrics import accuracy_score

# Splitting IRIS Dataset 
x_train,x_test,y_train,y_test=train_test_split(X,Y,test_size=.2)

# Training Machine Learning Model (KNN)
classifier=neighbors.KNeighborsClassifier()
classifier.fit(x_train,y_train)
predictions=classifier.predict(x_test)
print("Predicted Values")
print(predictions)
print("Observed Values")
print(y_test)

# Accuracy of Machine Learning Model (KNN)
print("Accuracy")
print(accuracy_score(y_test,predictions))